aboutsummaryrefslogtreecommitdiffstats
path: root/target/linux/apm821xx/image/mbl_gen_hdd_img.sh
diff options
context:
space:
mode:
authorChristian Lamparter <chunkeey@googlemail.com>2016-07-20 15:44:54 +0200
committerFelix Fietkau <nbd@nbd.name>2016-07-22 09:48:12 +0200
commitdc7efaefb53d4671893add07934839eb8d44934d (patch)
tree712375d1b97a8cea26ce5a97ac5cff14146937a3 /target/linux/apm821xx/image/mbl_gen_hdd_img.sh
parentd37d16488c7f41306daf0d6bc6ba948b3ee547a5 (diff)
downloadupstream-dc7efaefb53d4671893add07934839eb8d44934d.tar.gz
upstream-dc7efaefb53d4671893add07934839eb8d44934d.tar.bz2
upstream-dc7efaefb53d4671893add07934839eb8d44934d.zip
apm821xx: add support for the Western Digital MyBook Live Series
Hardware Highlights: This patch adds support for Western Digital MyBook Live Series: CPU: AMCC PowerPC UNKNOWN (PVR=12c41c83) at 800 MHz (PLB=200, OPB=100, EBC=100 MHz) 32 kB I-Cache 32 kB D-Cache, 256 kB L2-Cache, 32 kB OnChip Memory Board: Apollo-3G - APM82181 Board, 1*SATA DRAM: 256 MB (2x NT5TU64M16GG-AC) FLASH: 512 kB (SST 39VF040) Ethernet: 1xRGMII - 1 Gbit - Broadcom PHY BCM54610 WARNING: The serial port needs a TTL/RS-232 v3.3 level converter! The MyBook Live Duo additionally features a 1x USB 2.0 host port and can support a second hard-drive. This target produces two images for a target. 1. ext4 image The extracted/raw image can be directly installed on the internal HDD via "dd if=img.ext4 of=/dev/sdX". This can either be done in place with the stock MyBook Live firmware via ssh. Or by removing the HDD and writing the image with a different PC. The the compressed images are useful for sysupgrade. 2. recovery.tar image for TFTP and Serial. extract the recovery.tar to a TFTP server directory. On the MyBook Live (Duo) serial port - Hit Enter during u-boot and insert: # setenv serverip 192.168.1.254; setenv ipaddr 192.168.1.1; run net_self Where 192.168.1.254 is your TFTP server. Signed-off-by: Christian Lamparter <chunkeey@gmail.com>
Diffstat (limited to 'target/linux/apm821xx/image/mbl_gen_hdd_img.sh')
-rwxr-xr-xtarget/linux/apm821xx/image/mbl_gen_hdd_img.sh27
1 files changed, 27 insertions, 0 deletions
diff --git a/target/linux/apm821xx/image/mbl_gen_hdd_img.sh b/target/linux/apm821xx/image/mbl_gen_hdd_img.sh
new file mode 100755
index 0000000000..589dcf9150
--- /dev/null
+++ b/target/linux/apm821xx/image/mbl_gen_hdd_img.sh
@@ -0,0 +1,27 @@
+#!/usr/bin/env bash
+
+set -x
+[ $# -eq 3 ] || {
+ echo "SYNTAX: $0 <file> <bootfs image> <rootfs image>"
+ exit 1
+}
+
+OUTPUT="$1"
+BOOTFS="$2"
+ROOTFS="$3"
+let "BOOTFSSIZE=(`stat -c%s "$2"` + 1048575) / 1048576"
+let "ROOTFSSIZE=(`stat -c%s "$3"` + 1048575) / 1048576"
+
+head=4
+sect=63
+
+set `ptgen -o $OUTPUT -h $head -s $sect -l 4096 -t 83 -p ${BOOTFSSIZE}M -t 83 -p ${ROOTFSSIZE}M`
+
+BOOTOFFSET="$(($1 / 512))"
+BOOTSIZE="$(($2 / 512))"
+ROOTFSOFFSET="$(($3 / 512))"
+ROOTFSSIZE="$(($4 / 512))"
+
+dd bs=512 if="$BOOTFS" of="$OUTPUT" seek="$BOOTOFFSET" conv=notrunc
+dd bs=512 if="$ROOTFS" of="$OUTPUT" seek="$ROOTFSOFFSET" conv=notrunc
+